%define ALD_Ver		1.2.4

Name:         dbus

License:      GPL
Summary:      Free desktop message bus
Group:        System Environment/Libraries
Version:      1.6.8
Release:      2

Source: %{name}-%{version}.tar.xz
Source1: CROSS.sh
Source2: dbus-1.6.8-patches.tar.bz2
#Patch0: %{name}-%{version}_lc236.patch

%define DestDir		/System

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_arch} == "i386"
%define USE_ONLY_LIBC236 1
%else
%define USE_ONLY_LIBC236 0
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _libdir	%{_prefix}/%{_lib}
%define _libexecdir	%{_libdir}/dbus-1.0

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%define target %{_arch}-%{_vendor}-%{_os}%{__isa_bits}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin
%define target_  %{target}-

%define __os_install_post %{nil}

%define cross_sysconfdir %{csysdir}%{_sysconfdir}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_localstatedir %{csysdir}%{_localstatedir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{name}

%define cX11_libdir	%{csysdir}%{_prefix}/X11/%{_lib}
%define cX11_includedir	%{csysdir}%{_prefix}/X11/include

# ------------------- description ------------------------------------
%description
D-Bus is a simple system for interprocess communication and coordination.
#-------------------------------
%package X11
Summary:      dbus-launch
Group:        Development/Libraries
%description X11
dbus-launch - Utility to start a message bus from a shell script
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
#-------------------------------
%package doc
Summary:      doc for %{name}
Group:        Documentation
%description doc
doc for %{name}
#-------------------------------
%package %{TO_ARCH}
Summary:      %{name} Cross-%{TO_ARCH} Libraries
Group:        Development/Libraries
%description %{TO_ARCH}
%{name} Cross-%{TO_ARCH} Libraries

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

tar -xjf %SOURCE2

%if %{USE_ONLY_LIBC236}
patch -b -z .orig -p0<patches/inotify_lc236.patch
%endif

sed -i s:"dbus bus tools test doc":"dbus bus tools doc": Makefile.in

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif

CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections"
LDFLAGS="-Wl,--gc-sections"

export ac_cv_have_x="have_x=yes ac_x_includes=%{cX11_includedir} ac_x_libraries=%{cX11_libdir}"

%configure \
	--build=%{_build} \
%if %{_CROSS}
	--host=%{target} \
%endif
	--disable-static \
	--disable-libtool-lock \
	--enable-inotify \
	--enable-abstract-sockets \
	--with-dbus-daemondir=%{_sbindir} \
	&>FConfigure_log.txt

#	--enable-systemd 

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>Finstall_log.txt
rm $RPM_BUILD_ROOT%{_libdir}/*.la
#rm -r $RPM_BUILD_ROOT%{_localstatedir}/run/dbus
#mv $RPM_BUILD_ROOT%{_libdir}/dbus-1.0/include/dbus/dbus-arch-deps.h $RPM_BUILD_ROOT%{_includedir}/dbus-1.0/dbus/
#rm -r $RPM_BUILD_ROOT%{_libdir}/dbus-1.0/include

cp AUTHORS COPYING README $RPM_BUILD_ROOT%{docdir}/

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=%{BUILD_LOCAL_CROSS}
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%if %{BUILD_LOCAL_CROSS}
rm -r $RPM_BUILD_ROOT%{cross_sysconfdir}
rm -r $RPM_BUILD_ROOT%{cross_bindir}
rm -r $RPM_BUILD_ROOT%{cross_libdir}/dbus-1.0/dbus-daemon-launch-helper
rm -r $RPM_BUILD_ROOT%{cross_sbindir}
rm -r $RPM_BUILD_ROOT%{cross_mandir}
rm -r $RPM_BUILD_ROOT%{cross_datadir}/dbus-1
rm -r $RPM_BUILD_ROOT%{cross_docdir}/*.html
rm $RPM_BUILD_ROOT%{cross_docdir}/*.png
rm $RPM_BUILD_ROOT%{cross_docdir}/*.svg
rm -r $RPM_BUILD_ROOT%{cross_localstatedir}
%endif #BUILD_LOCAL_CROSS
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-X11-$SE $DD/%{name}-X11-$DE
  mv %{name}-devel-$SE $DD/%{name}-devel-$DE
  mv %{name}-doc-$SE $DD/%{name}-doc-$DE
%if %{BUILD_LOCAL_CROSS}
  mkdir -p $DDC
  mv %{name}-%{TO_ARCH}-$SE $DDC/%{name}-%{TO_ARCH}-$DEC
%endif #BUILD_LOCAL_CROSS
popd


# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r etc usr var $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%if %{BUILD_LOCAL_CROSS}
  TMP_TO=$DDC/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{TO_ARCH}-%{version}-%{release}.%{_build_cpu}
  mkdir -p $tmp
  cp -r cross $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
%endif
popd
%endif  #BUILD_TAR

%post
if [ ! -e /etc/init.d/dbus ]; then
  cat > /etc/init.d/dbus <<EOF
#!/bin/sh

PATH=/sbin:/bin:/usr/sbin:/usr/bin

. /etc/colorrc

test -x /usr/sbin/dbus-daemon || exit 0

test -f /etc/aldccp/system || exit 0
. /etc/aldccp/system

case "\$1" in
    start)
	if test x\$DBUS_START = x"yes"; then
	    if test -d /var/run/dbus -a -e /var/run/dbus/pid; then
		echo -n "dbus already started;"
		echo "\$rc_Err"
		exit 0
	    fi

	    if test ! -d /var/run/dbus; then
		mkdir -p /var/run/dbus
		chown messagebus /var/run/dbus
		chgrp messagebus /var/run/dbus
	    fi

	    if test -x /usr/bin/dbus-uuidgen; then
		/usr/bin/dbus-uuidgen --ensure
	    fi
	    echo -n "Starting dbus... "

	    /usr/sbin/dbus-daemon --system

	    if test \$? != 0; then
		echo "\$rc_Err"
	    else
		echo "\$rc_Ok"
	    fi
	fi
	;;
    stop)
	if test -d /var/run/dbus -a -e /var/run/dbus/pid; then
	    echo -n "Shut Down dbus... "
	    pid=\`cat /var/run/dbus/pid\`
	    kill \$pid
	    if test \$? != 0; then
		echo "\$rc_Err"
		exit 1
	    else
		echo "\$rc_Ok"
	    fi
	    rm -rf /var/run/dbus
	fi
        ;;
    *)
	echo "Usage: {start|stop}"
	exit 3
	;;
esac
EOF
chmod 0740 /etc/init.d/dbus
fi

# ------------------- Files ------------------------------------------
%Files
%{_sysconfdir}
%{_bindir}
%exclude %{_bindir}/dbus-launch
%{_libdir}/*.so.*
%{_libdir}/dbus-1.0/dbus-daemon-launch-helper
%{_sbindir}
%{_datadir}/dbus-1
%{_mandir}
%exclude %{_mandir}/man1/dbus-launch.1.gz
%{docdir}/AUTHORS
%{docdir}/COPYING
%{docdir}/README
%{docdir}/system-activation.txt
%{_localstatedir}

%files X11
%{_bindir}/dbus-launch
%{_mandir}/man1/dbus-launch.1.gz

%files devel
%{_includedir}
%{_libdir}/*.so
%{_libdir}/dbus-1.0/include
%{_libdir}/pkgconfig

%files doc
%{docdir}/*.html
%{docdir}/diagram.*

# ------------------- Cross Files ------------------------------------
%if %{BUILD_LOCAL_CROSS}

%Files %{TO_ARCH}
%{cross_libdir}
%{cross_includedir}
%{cross_docdir}/AUTHORS
%{cross_docdir}/COPYING
%{cross_docdir}/README
%{cross_docdir}/system-activation.txt

%endif #!BUILD_LOCAL_CROSS
